#ifndef DEMO_H
#define DEMO_H

#include <QMainWindow>
#include <QGraphicsScene>
#include <QTreeWidgetItem>
#include <QTableWidgetItem>

#include "view.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow (QWidget * parent = nullptr);
    ~MainWindow ();

    void openFile (QString fileName);
    void saveFile(QString fileName);
    void refreshTree ();

    QTableWidgetItem * addTableLine (QString name, QString value);
    void addColorLine (QString name, QColor value);
    void refreshTable (QGraphicsItem * item);

private slots:
    void on_actionOpen_triggered ();
    void on_actionSave_triggered ();

    void on_actionRun_triggered ();
    void on_actionQuit_triggered ();

    void on_tree_itemDoubleClicked (QTreeWidgetItem *item, int column);

    void on_actionCopy_triggered();

    void on_actionPaste_triggered();

private:
    Ui::MainWindow * ui;
    QGraphicsScene * scene;
    // Scene * scene;
};

#endif // DEMO_H
