#include "property.h"

#include <QPen>

PropertyTable::PropertyTable (QWidget * parent) :
    QTableWidget (parent)
{
    setColumnCount(2);
    QStringList labels;
    labels << "Name" << "Value";
    setHorizontalHeaderLabels (labels);
}

PropertyTable::~PropertyTable ()
{
}

QTableWidgetItem * PropertyTable::addTableLine (QString name, QString value)
{
    int cnt = rowCount();
    setRowCount(cnt+1);

    QTableWidgetItem * cell = new QTableWidgetItem;
    cell->setText (name);
    setItem (cnt, 0, cell);

    cell = new QTableWidgetItem;
    cell->setText (value);
    setItem (cnt, 1, cell);

    return cell;
}

void PropertyTable::addColorLine (QString name, QColor value)
{
    QTableWidgetItem * cell = addTableLine (name, value.name());
    cell->setData (Qt::DecorationRole, value);
}

void PropertyTable::displayProperties (QGraphicsItem * item)
{
    setRowCount (0);

    addTableLine ("tooltip", item->toolTip());
    addTableLine ("x", QString::number (item->x()));
    addTableLine ("y", QString::number (item->y()));

    if (QAbstractGraphicsShapeItem * shape = dynamic_cast < QAbstractGraphicsShapeItem * > (item))
    {
        addColorLine ("pen", shape->pen().color() );
        addColorLine ("brush", shape->brush().color() );
    }
}
