#include "view.h"
#include "drag.h"

#include <QAbstractGraphicsShapeItem>
#include <QGraphicsSceneDragDropEvent>
#include <QMimeData>

#include <iostream>
using namespace std;

/* ---------------------------------------------------------------------- */

/*
View::View (QWidget * parent) :
    QGraphicsView (parent)
{
}

View::~View ()
{
}
*/

/* ---------------------------------------------------------------------- */

/*
Scene::Scene ()
{
}

bool Scene::event (QEvent * event)
{
   QEvent::Type t = event->type ();
   if (t == QEvent::DragEnter)
       cout << "DragEnter event" << endl;
   if (t == QEvent::Drop)
       cout << "Drop event" << endl;
   return QGraphicsScene::event (event);
}
*/

void Scene::dragEnterEvent (QGraphicsSceneDragDropEvent * event)
{
    const QMimeData * mimeData = event->mimeData();
    if (mimeData->hasColor() || mimeData->hasFormat (shapeFormat))
    {
        event->setAccepted (true);
    }
}

// see http://stackoverflow.com/questions/4177720/accepting-drops-on-a-qgraphicsscene
void Scene::dragMoveEvent (QGraphicsSceneDragDropEvent *event)
{
    const QMimeData * mimeData = event->mimeData();
    if (mimeData->hasColor() || mimeData->hasFormat (shapeFormat))
    {
        event->setAccepted (true);
    }
}

void Scene::dropEvent (QGraphicsSceneDragDropEvent * event)
{
    const QMimeData * mimeData = event->mimeData();
    if (mimeData->hasColor())
    {
           QColor color =  mimeData->colorData().value <QColor> ();
           // addLine (0, 0, 100, 200, color);

           QGraphicsItem * item = itemAt (event->scenePos (), QTransform ()); // do not use event->pos()
           QAbstractGraphicsShapeItem * shape = dynamic_cast < QAbstractGraphicsShapeItem * > (item);

           if (shape != nullptr)
           {
               if (event->proposedAction() == Qt::CopyAction) /* ctrl */
                  shape->setPen (color);
               else
                  shape->setBrush (color);
           }
    }
    if (mimeData->hasFormat (shapeFormat))
    {
        QString code = mimeData->data (shapeFormat);
        // if (global_win != NULL)
        //   global_win->addGraphicsItem (shape, code, event->proposedAction() == Qt::MoveAction);
    }
}

/* ---------------------------------------------------------------------- */

